/*
 * MATLAB Compiler: 3.0
 * Date: Wed Apr 21 09:06:23 2004
 * Arguments: "-B" "macro_default" "-O" "all" "-O" "fold_scalar_mxarrays:on"
 * "-O" "fold_non_scalar_mxarrays:on" "-O" "optimize_integer_for_loops:on" "-O"
 * "array_indexing:on" "-O" "optimize_conditionals:on" "-x" "-W" "mex" "-L" "C"
 * "-t" "-T" "link:mexlibrary" "libmatlbmx.mlib" "powereig" 
 */
#include "powereig.h"
#include "libmatlbm.h"
static mxArray * _mxarray0_;
static mxArray * _mxarray1_;
static mxArray * _mxarray2_;

void InitializeModule_powereig(void) {
    _mxarray0_ = mclInitializeDouble(1.0);
    _mxarray1_ = mclInitializeDouble(10.0);
    _mxarray2_ = mclInitializeDouble(0.0);
}

void TerminateModule_powereig(void) {
    mxDestroyArray(_mxarray2_);
    mxDestroyArray(_mxarray1_);
    mxDestroyArray(_mxarray0_);
}

static mxArray * Mpowereig(mxArray * * value,
                           int nargout_,
                           mxArray * start,
                           mxArray * A,
                           mxArray * toler);

_mexLocalFunctionTable _local_function_table_powereig
  = { 0, (mexFunctionTableEntry *)NULL };

/*
 * The function "mlfPowereig" contains the normal interface for the "powereig"
 * M-function from file "c:\documents and settings\raoul\my
 * documents\projects\majorization\referee report\power method\powereig.m"
 * (lines 1-20). This function processes any input arguments and passes them to
 * the implementation version of the function, appearing above.
 */
mxArray * mlfPowereig(mxArray * * value,
                      mxArray * start,
                      mxArray * A,
                      mxArray * toler) {
    int nargout = 1;
    mxArray * vec = NULL;
    mxArray * value__ = NULL;
    mlfEnterNewContext(1, 3, value, start, A, toler);
    if (value != NULL) {
        ++nargout;
    }
    vec = Mpowereig(&value__, nargout, start, A, toler);
    mlfRestorePreviousContext(1, 3, value, start, A, toler);
    if (value != NULL) {
        mclCopyOutputArg(value, value__);
    } else {
        mxDestroyArray(value__);
    }
    return mlfReturnValue(vec);
}

/*
 * The function "mlxPowereig" contains the feval interface for the "powereig"
 * M-function from file "c:\documents and settings\raoul\my
 * documents\projects\majorization\referee report\power method\powereig.m"
 * (lines 1-20). The feval function calls the implementation version of
 * powereig through this function. This function processes any input arguments
 * and passes them to the implementation version of the function, appearing
 * above.
 */
void mlxPowereig(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[3];
    mxArray * mplhs[2];
    int i;
    if (nlhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: powereig Line: 1 Column:"
            " 1 The function \"powereig\" was called with m"
            "ore than the declared number of outputs (2)."),
          NULL);
    }
    if (nrhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: powereig Line: 1 Column:"
            " 1 The function \"powereig\" was called with m"
            "ore than the declared number of inputs (3)."),
          NULL);
    }
    for (i = 0; i < 2; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 3 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 3; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    mplhs[0] = Mpowereig(&mplhs[1], nlhs, mprhs[0], mprhs[1], mprhs[2]);
    mlfRestorePreviousContext(0, 3, mprhs[0], mprhs[1], mprhs[2]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 2 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 2; ++i) {
        mxDestroyArray(mplhs[i]);
    }
}

/*
 * The function "Mpowereig" is the implementation version of the "powereig"
 * M-function from file "c:\documents and settings\raoul\my
 * documents\projects\majorization\referee report\power method\powereig.m"
 * (lines 1-20). It contains the actual compiled code for that M-function. It
 * is a static function and must only be called from one of the interface
 * functions, appearing below.
 */
/*
 * function [vec,value]=powereig(start,A,toler)
 */
static mxArray * Mpowereig(mxArray * * value,
                           int nargout_,
                           mxArray * start,
                           mxArray * A,
                           mxArray * toler) {
    mexLocalFunctionTable save_local_function_table_
      = mclSetCurrentLocalFunctionTable(&_local_function_table_powereig);
    mxArray * vec = NULL;
    mxArray * y = NULL;
    mxArray * n = NULL;
    mxArray * x = NULL;
    mxArray * dd = NULL;
    mclCopyArray(&start);
    mclCopyArray(&A);
    mclCopyArray(&toler);
    /*
     * %
     * %Power method for computing eigenvalues
     * %
     * dd=1;
     */
    mlfAssign(&dd, _mxarray0_);
    /*
     * x=start;
     */
    mlfAssign(&x, mclVa(start, "start"));
    /*
     * n=10;
     */
    mlfAssign(&n, _mxarray1_);
    /*
     * while dd> toler
     */
    while (mclGtBool(mclVv(dd, "dd"), mclVa(toler, "toler"))) {
        /*
         * y=A*x;
         */
        mlfAssign(&y, mclMtimes(mclVa(A, "A"), mclVv(x, "x")));
        /*
         * dd=abs(norm(x)-n);
         */
        mlfAssign(
          &dd, mlfAbs(mclMinus(mlfNorm(mclVv(x, "x"), NULL), mclVv(n, "n"))));
        /*
         * n=norm(x);
         */
        mlfAssign(&n, mlfNorm(mclVv(x, "x"), NULL));
        /*
         * x=y/n;
         */
        mlfAssign(&x, mclMrdivide(mclVv(y, "y"), mclVv(n, "n")));
    /*
     * end
     */
    }
    /*
     * if n==0.0
     */
    if (mclEqBool(mclVv(n, "n"), _mxarray2_)) {
        /*
         * vec=x;
         */
        mlfAssign(&vec, mclVv(x, "x"));
    /*
     * else
     */
    } else {
        /*
         * vec=x/n;
         */
        mlfAssign(&vec, mclMrdivide(mclVv(x, "x"), mclVv(n, "n")));
    /*
     * end
     */
    }
    /*
     * value=n;
     */
    mlfAssign(value, mclVv(n, "n"));
    mclValidateOutput(vec, 1, nargout_, "vec", "powereig");
    mclValidateOutput(*value, 2, nargout_, "value", "powereig");
    mxDestroyArray(dd);
    mxDestroyArray(x);
    mxDestroyArray(n);
    mxDestroyArray(y);
    mxDestroyArray(toler);
    mxDestroyArray(A);
    mxDestroyArray(start);
    mclSetCurrentLocalFunctionTable(save_local_function_table_);
    return vec;
}
